function phix = applyQuadPhi(x)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

% define features
D1 = size(x,1);
D2 = size(x,2);

temp = zeros(D1,1+D2+D2*(D2+1)*0.5);
temp(:,1) = ones(D1,1); % bias
temp(:,2:(1+D2)) = x; % linear
% quadratic terms
for k1 = 1 : D1
    counter = D2+2;
    for i1 = 1 : D2
        for j1 = i1:D2
            temp(k1,counter) = x(k1,i1)*x(k1,j1);
            counter = counter + 1;
        end
    end
end
phix = temp;
