function facets = getFacetsForVertex(Trig,vin)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

% facets = facetId , localIndexOfVertex
% localIndexOfVertex = 1,2 or 3

facets = [];

firsts = Trig.Facets(:,1);
seconds = Trig.Facets(:,2);
thirds = Trig.Facets(:,3);

fins1 = find( firsts==vin);
fins2 = find( seconds==vin);
fins3 = find( thirds==vin);

for j = 1 : length(fins1)
    facets = [facets;[fins1(j),1]];
end

for j = 1 : length(fins2)
    facets = [facets;[fins2(j),2]];
end

for j = 1 : length(fins3)
    facets = [facets;[fins3(j),3]];
end



