function symdata = YAxisSymmetry(xyz,n,m,XMiddle)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

N = size(xyz,1);
M = size(xyz,2);
symdata = zeros(size(xyz,1),size(xyz,2));
for i=1:N
    tmp = zeros(3,M/3);
    tmp2 = zeros(3,M/3);
    tmp(1,:) = xyz(i,1:3:end);   
    tmp(2,:) = xyz(i,2:3:end);   
    tmp(3,:) = xyz(i,3:3:end);   
    for k=1:n
        for j=1:m
            tmp2(1,(k-1)*m+j) = XMiddle - (tmp(1,(k-1)*m+m-j+1)-XMiddle);
            tmp2(2,(k-1)*m+j) = tmp(2,(k-1)*m+m-j+1);
            tmp2(3,(k-1)*m+j) = tmp(3,(k-1)*m+m-j+1);
        end
    end
    symdata(i,:) = reshape(tmp2,1,M);
end
