function [PCs,Var] = computePCABases(data,nx,ny,mirrorDataP)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

N = size(data,1);
dataMean = mean(data);
mx = mean(dataMean(1:3:end));
my = mean(dataMean(2:3:end));

if(nargin==1)
    mirrorDataP = 0;
end


if(mirrorDataP)
    datax = XAxisSymmetry(data,nx,ny,mx);
    datay = YAxisSymmetry(data,nx,ny,my);
    dataxy = YAxisSymmetry(datax,nx,ny,my);
    data = [data;datax;datay;dataxy];
end

%[PCs,Var] = pcacov(data);

% dataMean = mean(data);
% data = data - repmat(dataMean,size(data,1),1);
[PCs,Ws,Var] = princomp(data);
% Ws = Ws(1:N,:);