function model = learnGP(X,Y,kernType,params)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

options = gpOptions('ftc');
options.kern = kernType;

model = gpCreate(size(X,2), size(Y,2), X, Y, options);

for i = 1 : length(params)
   
   if(strcmp(kernType{i},'rbf'))
       model.kern.comp{i}.inverseWidth = params{i};
       model.kern.comp{i}.variance = 1;
   elseif(strcmp(kernType{i},'lin'))
       model.kern.comp{i}.variance = params{i};
       model.kern.comp{i}.variance = 1;
   end
   
   if(strcmp(kernType{i},'bias'))
       model.kern.comp{i}.variance = params{i};
   end
   
   if(strcmp(kernType{i},'white'))
       model.kern.comp{i}.variance = params{i};
   end
end


params = gpExtractParam(model);
model = gpExpandParam(model, params);




