function WNC = learnUnconstraintW(X,Y,lambda)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

N = size(Y,2);
NM = size(kron(speye(N),X(1,:)),2);

nd = size(Y,1);
A = zeros(nd*N+NM,NM);
b = zeros(nd*N+NM,1);

for i = 1 : nd    
    A((i-1)*N+1:i*N,:) = sparse(kron(speye(N),X(i,:)));
    b((i-1)*N+1:i*N,:) = Y(i,:)';            
end
A(nd*N+1:end,:) = sqrt(lambda)*speye(NM); % for all w's

WNC = sparse(A)\b;
WNC = full(WNC);

clear A;
clear b;
