function [Xall Yall Y Y0 Mesh My Sy dataIndsCell validIndsCell testInds M Nx Ny PCs Var] = loadDataLVM(dataset,numData,numValid,numTests,numTrial,sampleValidationDataP)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com

if(strcmp(dataset,'mesh9x9'))% mesh9x9
    M = 12;
    Nx = 9;
    Ny = 9;
    Mesh = LoadAndPlotTrig('dat/mesh',0);
    Y0 = reshape(Mesh.Coords',1,size(Mesh.Coords,1)*3);
    Yall = load('dat/vicon_cardboard_resized_inext.txt');
else
    error('unknown dataset');
end

Nall = size(Yall,1);
My = zeros(size(Yall,2),1);
Sy = eye(size(Yall,2));

% partition the data into test, labeled and unlabeled sets
if(sampleValidationDataP==0)
    [dataIndsCell validIndsCell testInds] = partitionDataRandom(Nall,numData,numValid,numTests,numTrial);
else
    [dataIndsCell validIndsCell testInds] = partitionDataRandom(Nall,numData,0,numTests,numTrial);
end

% compute bases and project the samples on them
Y = Yall - repmat(Y0,Nall,1);
trainingInds = setdiff(1:size(Y,1),testInds);
YTraining = Y(trainingInds,:);
[PCs,Var] = computePCABases(YTraining,Nx,Ny,0);
Xall = projectOnBases(Yall,Y0,PCs,M);

