function edges2sum = makeSumConstraintsMesh(nx,ny,edges)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com


% geodesic paths
geoPaths = cell(nx+ny,1);
for ii = 1 : ny
    geoPaths{ii} = (ii-1)*nx+1:1:ii*nx;
end
for ii = 1 : nx
    geoPaths{ii+ny} = ii:nx:(ny-1)*nx+ii;
end

edges2sum = cell(nx+ny,1);
% make geodesic constraints
for ii = 1 : length(edges2sum)   
    edges2sum{ii} = zeros(1,length(geoPaths(ii))-1);
    for jj = 1 : length(geoPaths{ii})-1
        eid = find(edges(1,:)==geoPaths{ii}(jj) & edges(2,:)==geoPaths{ii}(jj+1));
        edges2sum{ii}(jj)=eid;
    end
end



