function Ypredictions = predictGPQuadratic(Xt,Yt,model,My,Sy,Dy,Acam,Rt,use_gt,matches,Trig0,vind)

% Copyright (C) <2012>  <Aydin Varol, Mathieu Salzmann, Pascal Fua and Raquel Urtasun>
% 
% Implementation of CLVM method described in:
% A. Varol, M. Salzmann, P. Fua and R. Urtasun, A Constrained Latent Variable Model, 
% Conference on Computer Vision and Pattern Recognition, June 2012.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Aydin Varol, CVLab-EPFL, 2012.
% aydin.varol@gmail.com, www.aydinvarol.com



Ktrainq = kernCompute(model.kern,model.X);
kstq = kernCompute(model.kern,Xt,model.X);
alpha0Sq = pinv(Ktrainq)*model.y;
Ymqgp = kstq*alpha0Sq;
pr_temp = Ymqgp + repmat(My,size(Yt,1),1);




Ntest = size(Xt,1);
Ypredictions = zeros(Ntest,3*Dy);
indsu = find(triu(ones(Dy)));
indsd = find(eye(Dy));
for i=1:Ntest
    yty = zeros(Dy,Dy);
    yty(indsu) = pr_temp(i,:);
    yty = yty + yty';
    yty(indsd) = yty(indsd)./2;
    A = reshape(Yt(i,:),3,Dy);
    if(isnan(yty))
        1;
    end
    if(use_gt==1)
        A3 = findBestConfiguration(yty,A,[],[],[],1,[]);
    else
        A3 = findBestConfigurationTrig(yty,A,Acam,Rt,Trig0,0,matches{i});
    end
    Ypredictions(i,:) = reshape(A3,1,3*Dy);
    
    if(nargin>11 && vind>0)
        offset = Yt(i,vind*3-2:vind*3) - Ypredictions(i,vind*3-2:vind*3);
        Ypredictions(i,:) = Ypredictions(i,:) + repmat(offset,1,size(Ypredictions,2)/3);
    end
    
    
end
















